#include "Builder.h"


namespace armarx::armem::client::query
{

    Builder::Builder(DataMode dataMode) : dataMode(dataMode)
    {
    }

    QueryInput Builder::buildQueryInput() const
    {
        QueryInput input;
        input.memoryQueries = buildMemoryQueries();
        input.dataMode = dataMode;
        return input;
    }
    armem::query::data::Input Builder::buildQueryInputIce() const
    {
        return buildQueryInput().toIce();
    }

    armem::query::data::MemoryQuerySeq Builder::buildMemoryQueries() const
    {
        armem::query::data::MemoryQuerySeq memoryQueries;
        for (const CoreSegmentSelector& child : _children)
        {
            for (const armem::query::data::MemoryQueryPtr& query : child.buildQueries())
            {
                memoryQueries.push_back(query);
            }
        }
        return memoryQueries;
    }


    CoreSegmentSelector& Builder::coreSegments()
    {
        return _addChild();
    }

    CoreSegmentSelector& Builder::coreSegments(const CoreSegmentSelector& selector)
    {
        return _addChild(selector);
    }

}
