#pragma once

#include "BaseQueryProcessor.h"
#include "../base/ProviderSegmentQueryProcessorBase.h"

#include "EntityQueryProcessor.h"

namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class ProviderSegmentQueryProcessor :
        virtual public BaseQueryProcessor<wm::ProviderSegment, armem::query::data::ProviderSegmentQuery>,
        virtual public base::query_proc::ProviderSegmentQueryProcessorBase<wm::ProviderSegment>
    {
        using Base = BaseQueryProcessor<wm::ProviderSegment, armem::query::data::ProviderSegmentQuery>;

    public:
        ProviderSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            Base(dataMode), entityProcessor(dataMode)
        {}

        using Base::process;
        data::ProviderSegment processToIce(const armem::query::data::ProviderSegmentQuery& query, const wm::ProviderSegment& providerSegment) const
        {
            return toIce<data::ProviderSegment>(process(query, providerSegment));
        }

    protected:
        virtual EntityT entityProcessorProcess(const armem::query::data::EntityQuerySeq& q, const EntityT& s) const override
        {
            return entityProcessor.process(q, s);
        }

    private:
        EntityQueryProcessor entityProcessor;
    };
}
