#include "aron_conversions.h"

// STL
#include <string>

// Ice
#include <IceUtil/Time.h>

// RobotAPI
#include <RobotAPI/libraries/armem_robot_localization/TransformInterfaces.h>
#include <RobotAPI/libraries/armem_robot_localization/aron/Transform.aron.generated.h>


namespace armarx
{

    TransformHeader fromAron(const aron::TransformHeader& aronHeader)
    {
        TransformHeader header;

        header.parentFrame = aronHeader.parentFrame;
        header.frame = aronHeader.frame;
        header.agent = aronHeader.agent;
        header.timestamp = aronHeader.timestamp;

        return header;
    }


    void fromAron(const aron::Transform& aronTransform, Transform& transform)
    {
        transform.header = fromAron(aronTransform.header);
        transform.transform = aronTransform.transform;
    }


    aron::TransformHeader toAron(const TransformHeader& header)
    {
        aron::TransformHeader aronHeader;

        aronHeader.parentFrame = header.parentFrame;
        aronHeader.frame = header.frame;
        aronHeader.agent = header.agent;
        aronHeader.timestamp = header.timestamp;

        return aronHeader;
    }

    void toAron(const Transform& transform, aron::Transform& aronTransform)
    {
        aronTransform.header = toAron(transform.header);
        aronTransform.transform = transform.transform.matrix();
    }

}  // namespace armarx
